Renamed compress_vob_file method to encode_vob_file and moved to top of function...
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################
29 # Local Machine Settings:
30 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
31 # and the local conf file created by each local machine (rip_dvd.conf)
32 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
33 # This will allow you to override all the default values to meet your needs
34 # in a way that won't get clobbered when you pull updates from my GIT repo.
35 ##############################################################################
36 config="${0%/*}/rip_dvd.conf"
37 [ -e "${config}.dist" ] && . ${config}.dist
38 [ -e "${config}" ] && . ${config}
39
40 ##############################################################################################
41 # Command line processing
42 ##############################################################################################
43 typeset dvdname=""
44 typeset debug=""
45 typeset dest=""
46 typeset isofile=""
47 typeset vobfile=""
48 typeset dvdpath=""
49 typeset aspect=""
50 typeset SCALE=""
51 typeset CROP=""
52 typeset profile="xvid"
53 typeset extension=""
54 typeset -i keep_isofile=0
55 typeset -i keep_vobfile=0
56 typeset -i keep_dvdfolder=0
57 typeset -i keep_intermediate_files=0
58 typeset -i make_final_dest_vob=0
59 typeset -i make_final_dest_iso=0
60 typeset -i make_final_dest_folder=0
61 typeset -i make_final_dest_comp=0
62 typeset -i errors=0
63 typeset -i show_usage=0
64 typeset -i mirror_mode=0
65 typeset -i target_bitrate=0
66 typeset -i target_size=0
67 typeset -i audio_2ch=0
68 typeset -i invalid_feature_title=0
69 typeset -i feature_title_override=0
70 typeset -i mplayer_dumpstream_incompatibility=0
71
72 while (($#)) && getopts 2mvifkxht:n:d:b:s:t:a:p:e: opt "$@"
73 do
74     case $opt in
75         (n)     dvdname=$OPTARG;;
76         (d)     dest=$OPTARG;;
77         (b)     target_bitrate=$OPTARG;;
78         (s)     target_size=$OPTARG;;
79         (2)     audio_2ch=1;;
80         (v)     make_final_dest_vob=1;;
81         (i)     make_final_dest_iso=1;;
82         (f)     make_final_dest_folder=1;; 
83         (x)     make_final_dest_comp=1;;
84         (m)     mirror_mode=1;;
85         (k)     keep_intermediate_files=1;;
86         (t)     feature_title_override=$OPTARG;;
87         (a)     aspect=$OPTARG;;
88         (p)     profile=$OPTARG;;
89         (e)     extension=$OPTARG;;
90         (w)     set -$opt;;
91         (h)     show_usage=1;;
92         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
93         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
94     esac
95 done
96
97 shift $((OPTIND-1))
98
99 function usage() {
100     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
101     echo >&2 "Revision $REV"
102     echo >&2 "Options:"
103     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
104     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
105     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
106     echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
107     echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
108     echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
109     echo >&2 "                 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
110     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
111     echo >&2 "                 - xvid = AVI, Xvid codec, 2 pass encoding, original aspect, no scaling (default)"
112     echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
113     echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
114     echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
115     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, 480:320 scaling"
116     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, 320:240 scaling"
117     echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
118     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
119     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
120     echo >&2 "                 The default operation is non-mirror mode where only the main"
121     echo >&2 "                 feature title will be ripped."
122     echo >&2 "   -v            Make the final image a DVD VOB file"
123     echo >&2 "   -i            Make the final image a DVD ISO file"
124     echo >&2 "   -f            Make the final image a DVD folder"
125     echo >&2 "   -x            Make the final image a compressed file based on your profile selection"
126     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
127     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
128     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
129     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
130     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
131     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
132     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
133     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
134     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
135     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
136     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
137     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
138     echo >&2 ""
139     exit 2
140 }
141
142 if (($errors)) || (($show_usage))
143 then
144   usage
145 fi
146
147 # Sanity Check - Command Line Options 
148 if [ "$dest" == "" ]; then
149   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
150   usage
151 fi
152
153 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
154   echo "-E- You can't specify a bitrate, target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
155   usage
156 fi
157
158 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
159   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
160   usage
161 fi
162
163 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
164    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
165   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
166   usage
167 fi
168
169 if [ $mirror_mode -eq 1 ]; then
170   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
171      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
172     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
173     usage
174   fi
175 fi
176
177 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
178 if [ "$aspect" != "" ]; then
179   echo "$aspect" | grep -q "x"
180   if [ $? == 0 ]; then
181     echo "-E- You must specify the aspect option with a value whose format is W:H"
182     exit 1
183   fi
184   echo "$aspect" | grep -q ":"
185   if [ $? != 0 ]; then
186     SCALE=",scale -zoom -sws 9 -xy $aspect"
187   else
188     SCALE=",scale=$aspect"
189   fi
190 fi
191
192
193 # Sanity Check - Key executables
194 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
195 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
196 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
197 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
198 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
199 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
200 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
201 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
202
203 ##############################################################################################
204
205 typeset -i ripdvd
206 if [ -z "$dvdname" ]; then
207   # make sure the DVD device is accessible
208   volname $dev > /dev/null 2>&1
209   if [ $? != 0 ]; then
210     echo "-E- Can't access the DVD device $dev"
211     exit 1
212   fi
213   # now capture the volume name from the device
214   dvdname=`volname $dev | awk '{ print $1 }'`
215   ripdvd=1
216 else 
217   # check to see if dvdname is a full path to a real directory
218   # if it is, set dvdname and dvdpath appropriately
219   if [ -d "$dvdname" ]; then
220     dvdpath="$dvdname"
221     dvdname=`basename "$dvdname"`
222     keep_dvdfolder=1
223     if [ -z "$dvdname" ]; then
224      echo "-E- Unable to extract dvdname from path: $dvdpath"
225      exit 1
226     fi
227     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
228       echo "-E- You must supply a full path to a valid DVD folder with this option"
229       exit 1
230     fi
231   fi
232
233   # Check to see if dvdname is a full path to a file
234   if [ -f "$dvdname" ]; then
235     valid_file=0
236
237     # check to see if dvdname is a full path to an MPG2 (VOB) file
238     # if it is, set dvdname and vobfile appropriately
239     file "$dvdname" | grep -q "MPEG"
240     if [ $? == 0 ]; then
241       # It is a valid MPEG2 file, now strip the extension off our dvdname
242       vobfile="$dvdname"
243       dvdname=`basename "$dvdname"`
244       dvdname=${dvdname%.[^.]*}
245       keep_vobfile=1
246       valid_file=1
247     fi
248
249     # check to see if dvdname is a full path to an ISO file
250     # if it is, set dvdname and isofile appropriately
251     file "$dvdname" | grep -q "ISO"
252     if [ $? == 0 ]; then
253       # It is a valid ISO file, now strip the extension off our dvdname
254       isofile="$dvdname"
255       dvdname=`basename "$dvdname"`
256       dvdname=${dvdname%.[^.]*}
257       keep_isofile=1
258       valid_file=1
259     fi    
260
261     # If we didn't find a handler for the file above, complain
262     if [ $valid_file -eq 0 ]; then
263       echo "-E- Unsupported file type: $vobfile"
264       exit 1
265     fi
266   fi
267   ripdvd=0
268 fi
269
270 # remove bad characters from the dvdname
271 dvdname=${dvdname%.} # remove trailing '.' character
272
273 # add the suffix extension to the end of the dvdname
274 dvdname=$dvdname$extension
275
276 # make a "safe" dvdname (remove special characters)
277 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
278
279 # Make sure we have a non-empty dvdname
280 if [ -z "$dvdname" ]; then
281   echo "-E- unable to determine dvdname"
282   exit 1
283 fi
284
285 # make sure our vobfile value is set
286 if [ -z "$vobfile" ]; then
287   vobfile="$dest/$dvdname.VOB"
288 fi
289
290 # set up some variables to hold various logfiles
291 logfile="$logdir/$dvdname.log"
292 passlogfile="$tmpdir/$safedvdname.log"
293 ddrescuelog=`tempfile`
294 dvdauthorlog=`tempfile`
295 encodelog=`tempfile`
296 dumplog=`tempfile`
297
298 # create the tmpdir if it doesn't already exist
299 if [ ! -d "$tmpdir" ]; then
300   mkdir -p "$tmpdir"
301   if [ $? != 0 ]; then
302     echo "-E- Unable to create the tmpdir: $tmpdir"
303     exit 1
304   fi
305 fi
306
307 # create the logdir if it doesn't already exist
308 if [ ! -d "$logdir" ]; then
309   mkdir -p "$logdir"
310   if [ $? != 0 ]; then
311     echo "-E- Unable to create the logdir: $logdir"
312     exit 1
313   fi
314 fi
315
316 ##############################################################################################
317 # cleanup functions
318 ##############################################################################################
319 cleanup() { 
320   if [ $keep_intermediate_files -eq 0 ]; then
321     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
322     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
323     [[ -e "$encodelog" ]] && rm -f "$encodelog"
324     [[ -e "$dumplog" ]] && rm -f "$dumplog"
325   else
326     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
327     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
328     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
329     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
330   fi
331   echo ""
332 }
333
334 fatal_and_exit() {
335   if [[ -z "$1" ]]; then
336     msg="-E- control-c killed us"
337   else
338     msg=$1
339   fi
340   echo -e 2>&1 "$msg" | tee -a "$logfile"
341   if [[ -n "$mailto" ]]; then
342     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
343   fi
344   exit 1
345 }
346
347 # Call our cleanup functions on INT and EXIT signals
348 trap fatal_and_exit INT
349 trap cleanup EXIT
350
351 ##############################################################################################
352 # processing functions
353 ##############################################################################################
354
355 # encode the vob file into a compressed file format
356 function encode_vob_file {
357   typeset -i found_profile=0
358    
359   # XVID profile
360   if [ "$profile" == "xvid" ]; then
361     found_profile=1
362     final_output_file="$dest/$dvdname.avi"
363     mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
364     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
365     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
366     mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS"
367     video_encoder_opts[0]="bitrate=$target_bitrate"
368     video_encoder_opts[1]="threads=$mencoder_threads"
369     video_encoder_opts[2]="chroma_opt"
370     video_encoder_opts[3]="vhq=4"
371     video_encoder_opts[4]="bvhq=1"
372     video_encoder_opts[5]="quant_type=mpeg"
373     video_encoder_opts[6]="autoaspect"
374     for OPTS in "${video_encoder_opts[@]}"; do 
375       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
376     done
377
378     if [ $audio_2ch -eq 0 ]; then
379       # These options produce good 6 channel audio for linux and windows
380       mencoder_audio_opts="-oac copy"
381       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
382       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
383       mencoder_audioch_opts[1]="-af channels=6"
384       mencoder_audioch_opts[2]=""
385     else
386       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
387       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
388       mencoder_audioch_opts[0]=""
389     fi
390  
391   fi
392
393   # MP4 encoding profiles
394   if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
395     found_profile=1
396     final_output_file="$dest/$dvdname.mp4"
397     mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
398     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
399     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
400     mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
401
402     # Very High Quality (6fps)
403     if [ "$profile" == "mp4vhq" ]; then
404       video_encoder_opts[0]="bitrate=$target_bitrate"
405       video_encoder_opts[1]="threads=$mencoder_threads"
406       video_encoder_opts[2]="subq=6"
407       video_encoder_opts[3]="frameref=5"
408       video_encoder_opts[4]="bframes=3"
409       video_encoder_opts[5]="8x8dct"
410       video_encoder_opts[6]="me=umh"
411       video_encoder_opts[7]="b_pyramid"
412       video_encoder_opts[8]="weight_b"
413       video_encoder_opts[9]="partitions=all" 
414     fi
415     # High Quality (13fps)
416     if [ "$profile" == "mp4hq" ]; then
417       video_encoder_opts[0]="bitrate=$target_bitrate"
418       video_encoder_opts[1]="threads=$mencoder_threads"
419       video_encoder_opts[2]="subq=5"
420       video_encoder_opts[3]="frameref=2"
421       video_encoder_opts[4]="bframes=3"
422       video_encoder_opts[5]="8x8dct"
423       video_encoder_opts[6]="b_pyramid"
424       video_encoder_opts[7]="weight_b"
425     fi
426     # Fast (17fps)
427     if [ "$profile" == "mp4" ]; then
428       video_encoder_opts[0]="bitrate=$target_bitrate"
429       video_encoder_opts[1]="threads=$mencoder_threads"
430       video_encoder_opts[2]="subq=4"
431       video_encoder_opts[3]="bframes=2"
432       video_encoder_opts[4]="b_pyramid"
433       video_encoder_opts[5]="weight_b"
434     fi
435
436     for OPTS in "${video_encoder_opts[@]}"; do
437       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
438     done
439
440     if [ $audio_2ch -eq 0 ]; then
441       # These options produce good 6 channel audio for linux and windows
442       #mencoder_audio_opts="-oac copy"
443       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
444       #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
445       #mencoder_audioch_opts[1]="-af channels=6"
446       #mencoder_audioch_opts[2]=""
447       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
448       mencoder_audioch_opts[0]="-channels 6 -srate 48000"
449     else
450       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
451       #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
452       #mencoder_audioch_opts[0]=""
453       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
454       mencoder_audioch_opts[0]="-channels 2 -srate 48000"
455     fi
456
457   fi
458
459   # iphone and ipod MP4 profiles
460   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
461     found_profile=1
462     if [ "$profile" == "iphone" ]; then
463       # SCALE: 480x320
464       # scale width to 480, set height appropriately, but keep a multiple of 16
465       #SCALE=",scale=480:-10"
466       # scale the video down however far is necessary to fit in 480x320
467       SCALE=",dsize=480:320:0,scale=-8:-8"
468     else
469       # SCALE: 320x240
470       # scale width to 320, set height appropriately, but keep a multiple of 16
471       #SCALE=",scale=320:-10"
472       # scale the video down however far is necessary to fit in 320x240
473       SCALE=",dsize=320:240:0,scale=-8:-8"
474     fi
475     final_output_file="$dest/$dvdname.mp4"
476     mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
477     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
478     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
479     mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
480     video_encoder_opts[0]="bitrate=$target_bitrate"
481     video_encoder_opts[1]="threads=$mencoder_threads"
482     video_encoder_opts[2]="vbv_maxrate=1500"
483     video_encoder_opts[3]="vbv_bufsize=2000"
484     video_encoder_opts[4]="nocabac"
485     video_encoder_opts[5]="me=umh"
486     video_encoder_opts[6]="subq=6"
487     video_encoder_opts[7]="frameref=6"
488     video_encoder_opts[8]="trellis=1"
489     video_encoder_opts[9]="level_idc=30"
490     video_encoder_opts[10]="global_header"
491     video_encoder_opts[11]="bframes=0"
492     video_encoder_opts[12]="partitions=all"
493     for OPTS in "${video_encoder_opts[@]}"; do 
494       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
495     done
496
497     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
498     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
499   fi
500
501   if [ $found_profile -eq 0 ]; then
502     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
503   fi
504
505   # Do not edit this line. $mencoder_video_encoder_opts must be last
506   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
507   mencoder_retval=0
508
509   for PASS in 1 2 
510   do 
511     # Set some options based on which pass we are in
512     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
513     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
514     [ $PASS -eq 1 ] && output_file="/dev/null"
515     [ $PASS -eq 2 ] && output_file="$final_output_file"
516   
517     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
518     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
519     do
520       echo -e "   Encoding pass $PASS"
521       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
522       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
523       mencoder_retval=$? 
524       grep -q "\[channels\] Invalid" $encodelog
525       if [ $? != 0 ]; then          
526         break;
527       else
528         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
529       fi
530     done
531       
532     if [ $mencoder_retval != 0 ]; then
533       fatal_and_exit "-E- Unhandled mencoder error"
534     fi
535
536     # Concatenate the encode log to our main log file, greping out unwanted lines
537     cat $encodelog | grep -v "Pos:" >> "$logfile"
538
539   done
540 }
541
542 function make_dvd_iso_image {
543
544   isofile="$1"
545
546   # check to see if we have a dvdpath to rip from instead of $dev
547   if [ -z "$dvdpath" ]; then
548     # load the CSS codes in the DVD drive 
549     lsdvd $dev >> "$logfile"
550     if [ $? != 0 ]; then
551       fatal_and_exit "-E- lsdvd $dev failed" 
552     fi
553
554     # read the DVD, ignoring/skipping CRC errors
555     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
556     if [ $? != 0 ]; then
557       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
558     fi
559     cat "$ddrescuelog" >> "$logfile"
560   else
561     # rip from a path instead
562     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
563   fi
564 }
565
566 function make_dvd_iso_image_from_folder {
567   
568   src="$1"
569   dst="$2"
570   handle_error=$3
571   
572   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
573
574   # make an iso image out of our directory
575   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
576   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
577
578   # set the audio languages from the iso if it exists and is non-zero in size
579   if [ -s "$dst" ]; then
580     get_feature_title "$dst"
581     get_audio_id_from_iso "$dst"
582   fi
583
584   # make sure we were able to create the iso image from the folder given to us
585   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
586     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
587     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
588     # remove the bad iso file
589     [[ -e "$dst" ]] && rm -f "$dst"
590     # get the feature title from the DVD folder
591     get_feature_title "$dvdpath"
592     # create our main VOB file from the ISO
593     create_main_vob_with_mplayer "$dvdpath" 
594     # get our audio id from the VOB file
595     get_audio_id_from_vob "$vobfile"
596   fi
597 }
598
599 function make_dvdbackup_folder_image {
600   # extract the feature title from the DVD image
601   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
602   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
603   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
604   if [ $? != 0 ]; then
605     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
606   fi
607 }
608
609 function make_dvdauthor_folder_image {
610   # create a new DVD video of the feature title
611   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
612   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
613   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
614   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
615
616   # There is a chance that dvdauthor won't like some of the VOBs.
617   # We can't tell ahead of time which ones it will choke on. 
618   # So, we need to run it over and over again until it can process
619   # all the VOBs. If it can't handle one of them, run it through
620   # mencoder to fix it and try again. These errors are typically
621   # present due to the copy protection that ddrescue removed.
622   grep -q "SCR moves" $dvdauthorlog
623   while [ $? == 0 ]; do
624     # fix bad vobs that get the "SCR moves backwards" error:
625     #  STAT: Processing VTS_01_0.VOB...
626     #  ERR:  SCR moves backwards, remultiplex input.
627     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
628     if [[ ! -f "$badvob" ]]; then
629       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
630     fi
631     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
632     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
633     mv -f $badvob.fixed $badvob
634     echo "-> Creating DVD video $dest/$dvdname"
635     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
636     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
637     grep -q "SCR moves" $dvdauthorlog
638   done
639 }
640
641 function get_feature_title {
642   source="$1"
643   # if a feature title was given on the command line, use it
644   if [ $feature_title_override -ne 0 ]; then
645     feature_title=$feature_title_override
646     return 0
647   fi
648   # otherwise, use lsdvd to figure it out
649   if [ $ripdvd -eq 1 ]; then
650     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
651   else 
652     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
653   fi
654 }
655
656 function create_main_vob_with_cat {
657   # cd to the feature title DVD folder
658   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
659   if [ $? != 0 ]; then
660     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
661   fi
662
663   # concatenate all the VOBs together into 1 giant VOB
664   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
665   cat $vobs > "$tmpdir/$dvdname.VOB"
666
667   # cd back to the dir we started from
668   popd > /dev/null 2>&1
669 }
670
671 function create_main_vob_with_mplayer {
672
673   # argument processing  
674   source="$1"
675   remove_dumplog=$2
676
677   # make sure we have a valid feature title
678   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
679     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
680   fi
681
682   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
683   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
684     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
685     msg="$msg We also detected another condition that requires us to use dumpstream. "
686     msg="$msg\n    Unable to rip this DVD in the mode you requested."
687     fatal_and_exit "$msg"
688   fi
689
690   # use mplayer to create the main VOB file
691   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
692   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
693   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
694   if [ $? != 0 ]; then
695     cat $dumplog | grep -v "^A:" >> "$logfile"
696     fatal_and_exit "-E- Mplayer Failed"
697   fi
698   cat $dumplog | grep -v "^A:" >> "$logfile"
699   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
700 }
701
702 function get_audio_id_from_iso {
703   # Adjust our audio ID to find the english audio stream
704   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
705   iso="$1"
706   aidcheck=`tempfile`
707   aid=128
708   mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
709   grep -q "aid: $aid" $aidcheck
710   while [ $? == 1 ] && [ $aid -lt 159 ]; do
711     (( aid = aid + 1 ))
712     grep -q "aid: $aid" $aidcheck
713   done
714   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
715   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
716   # mencoder default DVD audio track language selection (english)
717   lang_opts="-aid $aid -alang en"
718 }
719
720 function get_crop_from_iso { 
721   FRAMES=10000
722   echo "-> Detecting black frame border crop value from ISO file"
723   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
724   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
725   [[ -e "md5sums" ]] && rm -f "md5sums"
726   CROP=`cat $dumplog | grep CROP | tail -1`
727   echo "   Found crop value of $CROP" >> "$logfile"
728   CROP=${CROP#* crop=}
729   CROP=${CROP%%\).*}
730   typeset -i CROPCHECK
731   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
732   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
733   if [ -z "$CROP" ]; then
734     fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
735   fi
736   if [ $CROPCHECK -lt 0 ]; then 
737     CROP=""
738   else 
739     CROP=",crop=$CROP"
740   fi
741   echo "   Setting mencoder crop filter to: $CROP"
742 }
743
744 function get_crop_from_vob { 
745   FRAMES=10000
746   echo "-> Detecting black frame border crop value from VOB file"
747   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
748   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
749   [[ -e "md5sums" ]] && rm -f "md5sums"
750   CROP=`cat $dumplog | grep CROP | tail -1`
751   echo "   Found crop value of $CROP" >> "$logfile"
752   CROP=${CROP#* crop=}
753   CROP=${CROP%%\).*}
754   typeset -i CROPCHECK
755   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
756   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
757   if [ -z "$CROP" ]; then
758     fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
759   fi
760   if [ $CROPCHECK -lt 0 ]; then 
761     CROP=""
762   else 
763     CROP=",crop=$CROP"
764   fi
765   echo "   Setting mencoder crop filter to: $CROP"
766 }
767
768 function get_audio_id_from_vob {
769   # Adjust our audio ID to find the english audio stream
770   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
771   vob="$1"
772   aidcheck=`tempfile`
773   aid=128
774   mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
775   grep -q "Found audio stream: $aid" $aidcheck
776   while [ $? == 1 ] && [ $aid -lt 159 ]; do
777     (( aid = aid + 1 ))
778     grep -q "Found audio stream: $aid" $aidcheck
779   done
780   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
781   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
782   # mencoder default DVD audio track language selection (english)
783   lang_opts="-aid $aid -alang en"
784 }
785
786 function check_vob_for_corrupted_start {
787   # check to see if the beginning of the DVD has a form of copy protection
788   # where they have deliberately broken the first X number of frames of the DVD.
789   # If we don't skip these, our resulting VOB file will not play.
790   badvobcheck=`tempfile`
791   endpos=360
792   skip=0
793   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
794   if [ $? != 0 ]; then
795     fatal_and_exit "-E- Mencoder Failed"
796   fi
797   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
798   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
799     (( skip = skip + 5 ))
800     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
801     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
802     if [ $? != 0 ]; then
803       fatal_and_exit "-E- Mencoder Failed"
804     fi
805     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
806   done
807   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
808
809   # cat the giant VOB into mencoder to create a playable VOB file
810   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
811   if [ $? != 0 ]; then
812     fatal_and_exit "-E- Mencoder Failed"
813   fi
814 }
815
816 function check_vob_for_completeness {
817   # check to make sure we got out a complete VOB.
818   # there is another kind of copy protection where the VOB's may
819   # have "MPG EOF" frames in the middle of the stream. 
820   # this causes mencoder to not process the entire VOB, and exit without any errors.
821   # detect this by seeing how much smaller the dst vob is from the src vob.
822   MAX_FILESIZE_DELTA_PERCENT=70
823   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
824   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
825   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
826   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
827     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
828     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
829     create_main_vob_with_mplayer "$isofile"
830     [[ -e "$dumplog" ]] && rm -f $dumplog
831     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
832     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
833     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
834       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
835     fi
836   fi
837 }
838
839 function check_vob_for_too_many_video_packets {
840   # If our earlier algorithm to work around this failed, throw an error.
841   # check to see if this DVD has a protection scheme we don't know how to work around
842   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
843   # for some reason, the video is black, while the audio rolls, then the video finally comes
844   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
845   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
846   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
847   grep -q "Too many video packets in the buffer:" "$logfile"
848   if [ $? == 0 ]; then
849     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
850     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
851     create_main_vob_with_mplayer "$isofile"
852     grep -q "Too many video packets in the buffer:" $dumplog
853     if [ $? == 0 ]; then
854       [[ -e "$dumplog" ]] && rm -f $dumplog
855       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
856     fi
857     [[ -e "$dumplog" ]] && rm -f $dumplog
858   fi
859 }
860
861 function check_vob_for_a52_crc_errors {
862   # Let's see if we can playback our newly created VOB file without any errors.
863   # if there are issues, let's detect them now, and try to recreate the VOB
864   # there are some forms of copy protection that have missed above, that evidence
865   # themselves when we try to playback the VOB file. This was added to deal with
866   # the "a52: CRC check failed" copy protection scheme.
867   MAX_ERRORS=10
868   ENDPOS=120
869   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
870   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
871   cat $dumplog | grep -v "^A:" >> "$logfile"
872   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
873   if [ $errors -gt $MAX_ERRORS ]; then
874     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
875     create_main_vob_with_mplayer "$isofile"
876     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
877     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
878     if [ $? != 0 ]; then
879       cat $dumplog | grep -v "^A:" >> "$logfile"
880       fatal_and_exit "-E- Mplayer Failed"
881     fi
882     cat $dumplog | grep -v "^A:" >> "$logfile"
883     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
884     if [ $errors -gt $MAX_ERRORS ]; then
885       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
886     fi
887   fi
888   [[ -e "$dumplog" ]] && rm -f $dumplog
889 }
890
891 function calculate_bitrate_from_target_size {
892   # determine what our bitrate needs to be if a target size was specified instead
893   if [ $target_size -ne 0 ]; then
894     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
895     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
896     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
897   fi
898 }
899
900 function create_dvdauthor_dvd_xml_file {
901   # make a dvdauthor xml menu file to create a valid DVD video from 
902   # this script does a good job, but we'll still need to clean it up a bit after it runs
903   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
904   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
905   if [ $? != 0 ]; then
906     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
907   fi
908
909   # replace the first line of the xml file to remove the bad dest path
910   awk -v line=1 -v new_content="<dvdauthor>" '{
911     if (NR == line) {
912       print new_content;
913     } else {
914       print $0;
915     }
916   }' dvd.xml > dvd.xml.new
917   mv -f dvd.xml.new dvd.xml
918   if [ $? != 0 ]; then
919     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
920   fi
921
922   # remove the "<video " property line from the xml file
923   cat dvd.xml | grep -v "<video" > dvd.xml.new
924   mv -f dvd.xml.new dvd.xml
925   if [ $? != 0 ]; then
926     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
927   fi
928   
929   # remove the extra <pgc>..</pgc> pairs
930   cat dvd.xml | awk 'BEGIN {x=1}
931   {
932     if ($0~"</pgc>") {x=0}
933     if (x==1) {print $0}
934     if ($0~"<pgc>") {x=1}
935   }' > dvd.xml.new
936   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
937   mv -f dvd.xml.new dvd.xml
938   if [ $? != 0 ]; then
939     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
940   fi
941
942   # remove the VTS_*_0.VOB file as this is just the main menu video clip
943   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
944   mv -f dvd.xml.new dvd.xml
945   if [ $? != 0 ]; then
946     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
947   fi
948 }
949
950 function check_for_mplayer_dumpstream_incompatibility {
951
952   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
953
954   if [ ! -e "$vobfile" ]; then
955     # mplayer dumpstream does not work on DVDs that obscure the feature title.
956     # A DVD that has 99 titles, where the longest title isn't the main feature
957     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
958     # out what the feature title is. This script will run through that flow if we
959     # set use_mplayer_dumpstream to 0. Check for this here.
960     if [ $ripdvd -eq 1 ]; then
961       lsdvd $dev | grep -q "Title: 99"
962     else
963       lsdvd "$isofile" | grep -q "Title: 99"
964     fi
965     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
966     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
967       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
968         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
969         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
970         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
971         invalid_feature_title=1
972       else 
973         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
974         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
975         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
976         use_mplayer_dumpstream=0
977         invalid_feature_title=1
978       fi
979       return
980     fi
981   fi
982
983   # There is another form of protection that causes the mplayer dumpstream to fail. 
984   # This can be detected by telling mplayer to parse the VOB file by copying its audio
985   # video streams to a dummy output file (/dev/null). Do that here to check for that 
986   # problem before continuing.
987   if [ -e "$vobfile" ]; then
988     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
989     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
990     grep -q "Too many audio packets in the buffer" $dumplog
991     if [ $? == 0 ]; then
992       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
993       use_mplayer_dumpstream=0
994       mplayer_dumpstream_incompatibility=1
995     fi
996     [[ -e "$dumplog" ]] && rm -f $dumplog
997   fi
998 }
999
1000 function fill_mythvideo_metadata {
1001
1002   # This function must be passed the filename as an argument
1003   # The filename must be a full path to the file
1004   filename="$1"
1005
1006   # Make sure the fill mythvideo metadata option has been set to 1
1007   if [ $fill_mythvideo_metadata -eq 0 ]; then
1008     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1009     return 0
1010   fi
1011
1012   # If the fill mythvideo metadata script is present, run it
1013   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1014   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1015     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1016     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1017   else
1018     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1019     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1020   fi
1021 }
1022
1023 # remove the intermediate VOB file
1024 function remove_intermediate_vob_file {
1025   if [ $keep_intermediate_files -eq 0 ]; then
1026     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1027   else
1028     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1029   fi
1030 }
1031
1032 # remove the original DVD image 
1033 function remove_intermediate_iso_file {
1034   [[ $keep_isofile -eq 1 ]] && return 1
1035   if [ $keep_intermediate_files -eq 0 ]; then
1036     [[ -e "$isofile" ]] && rm "$isofile"
1037   else
1038     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1039   fi
1040 }
1041
1042 # remove the intermediate dvdbackup folder
1043 function remove_intermediate_dvdbackup_folder {
1044   if [ $keep_intermediate_files -eq 0 ]; then
1045     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1046   else
1047     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1048   fi
1049 }
1050
1051 ##############################################################################################
1052 # MAIN
1053 ##############################################################################################
1054
1055 # Make a note of when this DVD rip started
1056 date=`date`
1057 echo -e "\n$date DVD rip started" >> "$logfile"
1058
1059 # Rip the DVD - Mirror Mode
1060 if [ $mirror_mode -eq 1 ]; then
1061   echo "-> Ripping DVD $dvdname to $dest"
1062
1063   # use ddrescue to make an ISO image of the disk
1064   make_dvd_iso_image "$dest/$dvdname.iso"
1065
1066   # add this video data to the mythtv DB
1067   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1068
1069   # eject the disk upon completion
1070   eject -T $dev
1071
1072   date=`date`
1073   echo "$date DVD rip completed" | tee -a "$logfile"
1074
1075   if [[ -n "$mailto" ]]; then
1076     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1077   fi
1078
1079 fi
1080
1081 # Rip the DVD - Main Title Feature Only
1082 if [ $mirror_mode -eq 0 ]; then
1083
1084   # Rip image from DVD
1085   if [ $ripdvd -eq 1 ]; then
1086     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1087     # use ddrescue to make an ISO image of the disk
1088     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1089   fi
1090
1091   # Rip image from DVD path
1092   if [ -n "$dvdpath" ]; then
1093     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1094     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1095   fi
1096
1097   # make sure our isofile value is set
1098   if [ -z "$isofile" ]; then
1099     isofile="$tmpdir/$dvdname.iso"
1100   fi
1101      
1102   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1103
1104     if [ ! -e "$vobfile" ]; then
1105       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1106       
1107       # get the feature title from the ISO
1108       get_feature_title "$isofile"
1109  
1110       # get the crop value from the ISO
1111       get_crop_from_iso
1112
1113       # check for mplayer dumpstream incompatibilities
1114       # if they exist, this method will set this mode to 0.
1115       check_for_mplayer_dumpstream_incompatibility
1116
1117       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1118
1119         # get our audio id from the ISO file
1120         get_audio_id_from_iso "$isofile"
1121
1122         # create our main VOB file from the ISO
1123         create_main_vob_with_mplayer "$isofile"
1124      
1125         # remove the intermediate VOB file
1126         remove_intermediate_vob_file
1127
1128         # it's possible that our VOB is still corrupted in some manner
1129         # check to make sure it is still a good VOB before continuing.
1130         check_for_mplayer_dumpstream_incompatibility
1131
1132       fi
1133  
1134       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1135
1136         # use dvdbackup to make a DVD folder of the feature title
1137         make_dvdbackup_folder_image
1138   
1139         # create our main VOB file
1140         create_main_vob_with_cat
1141
1142         # get our audio id from the VOB file
1143         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1144   
1145         # check for corrupted VOB start
1146         check_vob_for_corrupted_start
1147  
1148         # check to make sure our VOB is complete
1149         check_vob_for_completeness
1150
1151         # check to make sure our VOB doesn't have too many video packets
1152         check_vob_for_too_many_video_packets
1153
1154         # check to make sure our VOB doesn't have a52 crc errors
1155         check_vob_for_a52_crc_errors
1156
1157         # remove the intermediate VOB file
1158         remove_intermediate_vob_file
1159
1160       fi
1161
1162       # remove the intermediate ISO file
1163       remove_intermediate_iso_file
1164
1165     else
1166       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1167       # get our audio id from the VOB file
1168       get_audio_id_from_vob "$vobfile"
1169       # get the crop value from the VOB
1170       get_crop_from_vob
1171     fi
1172
1173     # encode the VOB file to a compressed file format
1174     if [ $make_final_dest_comp -eq 1 ]; then
1175       echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
1176
1177       # determine what our bitrate needs to be if a target size was specified instead
1178       calculate_bitrate_from_target_size        
1179      
1180       # encode the vob file into a compressed file format
1181       encode_vob_file
1182
1183       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1184         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1185         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1186       else
1187         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1188         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1189       fi
1190     fi
1191
1192   # add this video data to the mythtv DB
1193   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1194   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1195     
1196   else
1197
1198   # use dvdbackup to make a DVD folder of the feature title
1199   make_dvdbackup_folder_image
1200
1201   # cd to the feature title DVD folder
1202   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1203   if [ $? != 0 ]; then
1204     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1205   fi
1206   
1207   # create the dvd.xml file for dvdauthor
1208   create_dvdauthor_dvd_xml_file  
1209
1210   # make the final DVD folder image
1211   make_dvdauthor_folder_image
1212
1213   # add this video data to the mythtv DB
1214   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1215  
1216   # cd back to the dir we started from
1217   popd > /dev/null 2>&1
1218
1219   if [ $make_final_dest_iso -eq 1 ]; then
1220
1221     # make an iso image out of our directory
1222     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1223    
1224     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1225     if [ -s "$dest/$dvdname.iso" ]; then
1226       if [ $make_final_dest_folder -eq 0 ]; then
1227         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1228         # remove the folder of the DVD image now that we have a .iso version of it
1229         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1230       fi
1231     else
1232       # we created an empty iso file, remove it
1233       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1234       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1235       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1236     fi
1237  
1238     # add this video data to the mythtv DB
1239     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1240
1241   fi
1242
1243   fi
1244
1245   # remove the ddrescue DVD ISO image
1246   remove_intermediate_iso_file
1247
1248   # remove the tmp dvdbackup folder of the DVD image
1249   remove_intermediate_dvdbackup_folder
1250
1251   # eject the DVD disk upon completion
1252   [ $ripdvd -eq 1 ] && eject -T $dev
1253
1254   date=`date`
1255   echo "$date DVD rip completed" | tee -a "$logfile"
1256
1257   if [[ -n "$mailto" ]]; then
1258     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1259   fi
1260
1261 fi
1262
1263 ##############################################################################################